<template>
  <header :class="headerClass">
    <aside>Destination {{ step.action === 'ChangeCar' ? 'suivante' : '' }}</aside>
    <h1>{{ step.location.label }} - {{ date }}</h1>
    <h2>{{ step.car && step.car.label }}</h2>
    <ride-details
      v-if="step.action !== 'ChangeCar' && step.type === 'ride'"
      :step="step"
    />
    <shuttle-details
      v-else-if="step.action !== 'ChangeCar' && step.type === 'shuttle'"
      :step="step"
    />
    <ec-button
      :disabled="pending"
      @click.native="emitClick"
    >
      {{ buttonContent }}
    </ec-button>
  </header>
</template>

<script>
import { DateTime } from 'luxon';
import ecButton from '~/components/elements/button.vue';
import {
  STEP_CHANGE_CAR,
  STEP_GET_PASSENGER,
  STEP_WAIT_PASSENGER,
  STEP_DRIVE_PASSENGER,
  STEP_DROP_PASSENGER,
  STEP_GO_TO_STOP,
} from '~/store/steps';
import shuttleDetails from '~/components/step/shuttle-details.vue';
import rideDetails from '~/components/step/ride-details.vue';

export default {
  components: {
    ecButton,
    rideDetails,
    shuttleDetails,
  },
  props: {
    step: {
      type: Object,
      required: true,
    },
    pending: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    date() {
      return DateTime.fromISO(this.step.date).toLocaleString({ hour: '2-digit', minute: '2-digit', hour12: false });
    },
    buttonContent() {
      switch (this.step.action) {
        case STEP_CHANGE_CAR:
          return 'Véhicule changé';
        case STEP_GET_PASSENGER:
          return 'Commencer le trajet';
        case STEP_WAIT_PASSENGER:
          return 'Je suis sur place';
        case STEP_DRIVE_PASSENGER:
          return 'Passager pris en charge';
        case STEP_DROP_PASSENGER:
          return 'Je suis à destination';
        case STEP_GO_TO_STOP:
          return 'Arrivé à l\'arrêt';
        default:
          return '';
      }
    },
    headerClass() {
      switch (this.step.action) {
        case STEP_CHANGE_CAR:
          return 'status-warning';
        case STEP_GET_PASSENGER:
          return 'status-drive';
        case STEP_WAIT_PASSENGER:
          return 'status-wait';
        case STEP_DRIVE_PASSENGER:
          return 'status-drive';
        case STEP_DROP_PASSENGER:
          return 'status-end';
        case STEP_GO_TO_STOP:
          return 'status-shuttle';
        default:
          return '';
      }
    },
  },
  methods: {
    emitClick() {
      this.$emit('stepDone', this.step);
    },
  },
};
</script>

<style lang="scss" scoped>
  @import "~assets/css/head";

  header {
    background-color: gray;
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    padding: 1em;
    color: $white;
    &.status {
      &-warning {
        background-color: $red;
      }
      &-drive {
        background-color: $primary;
      }
      &-wait {
        background-color: $warning;
      }
      &-end {
        background-color: $success;
      }
      &-shuttle {
        background-color: $blue-light;
      }
    }

    h1, h2 {
      font-weight: 700;
      text-transform: uppercase;
    }
    h1 {
      font-size: 2em;
    }
    h2 {
      font-size: 1.5em;
    }
    button {
      width: 100%;
      color: $black;
      margin-top: 1em;
    }
    .details {
      /deep/ strong {
        color: inherit;
      }
    }
  }
</style>
